import { HazelBuffer } from "@skeldjs/util";
import { SpawnType } from "@skeldjs/constant";
import { ExtractEventTypes } from "@skeldjs/events";
import { Networkable, NetworkableEvents } from "../Networkable";
import { Hostable } from "../Hostable";
import { NetworkableConstructor } from "../Heritable";
export interface LobbyBehaviourData {
}
export declare type LobbyBehaviourEvents<RoomType extends Hostable = Hostable> = NetworkableEvents<RoomType> & ExtractEventTypes<[]>;
/**
 * Represents a room object for the Lobby map.
 *
 * See {@link LobbyBehaviourEvents} for events to listen to.
 */
export declare class LobbyBehaviour<RoomType extends Hostable = Hostable> extends Networkable<LobbyBehaviourData, LobbyBehaviourEvents<RoomType>, RoomType> {
    constructor(room: RoomType, spawnType: SpawnType, netid: number, ownerid: number, flags: number, data?: HazelBuffer | LobbyBehaviourData);
    getComponent<T extends Networkable>(component: NetworkableConstructor<T>): T | undefined;
    get owner(): RoomType;
}
