"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DeconSystem = exports.DeconState = void 0;
const constant_1 = require("@skeldjs/constant");
const SystemStatus_1 = require("./SystemStatus");
exports.DeconState = {
    Enter: 0x1,
    Closed: 0x2,
    Exit: 0x4,
    HeadingUp: 0x8,
};
/**
 * Represents a system responsible for the decontamination doors.
 *
 * See {@link DeconSystemEvents} for events to listen to.
 */
class DeconSystem extends SystemStatus_1.SystemStatus {
    constructor(ship, data) {
        var _a;
        super(ship, data);
        this.systemType = constant_1.SystemType.Decontamination;
        (_a = this.timer) !== null && _a !== void 0 ? _a : (this.timer = 10000);
        this.state || (this.state = 0);
    }
    Deserialize(reader, spawn) {
        if (!spawn) {
            this.timer = reader.byte();
            this.state = reader.byte();
        }
    }
    Serialize(writer, spawn) {
        if (!spawn) {
            writer.byte(this.timer);
            writer.byte(this.state);
        }
    }
}
exports.DeconSystem = DeconSystem;
DeconSystem.systemType = constant_1.SystemType.Decontamination;
//# sourceMappingURL=DeconSystem.js.map